Name:           appcore-agent
Version:        1.4.2
Release:        1
License:        Apache-2.0
Summary:        Service Application basic
Group:          Application Framework/Service
Source0:        %{name}-%{version}.tar.gz
Source1001:     appcore-agent.manifest
BuildRequires:  cmake
BuildRequires:  pkgconfig(aul)
BuildRequires:  pkgconfig(capi-appfw-app-control)
BuildRequires:  pkgconfig(capi-appfw-app-common)
BuildRequires:  pkgconfig(capi-system-info)
BuildRequires:  pkgconfig(app-core-cpp)
BuildRequires:  pkgconfig(dlog)
BuildRequires:  pkgconfig(ecore-core)
BuildRequires:  pkgconfig(gmock)
BuildRequires:  pkgconfig(vconf)
BuildRequires:  pkgconfig(vconf-internal-keys)

%if 0%{?gcov:1}
BuildRequires:  lcov
%endif

%description
Service Application basic

%package devel
Summary:        Application Core Agent
Group:          Application Framework/Development
Requires:       %{name} = %{version}-%{release}

%description devel
appcore agent (developement files)

%package -n capi-appfw-service-application-devel
Summary:    service appliation
Group:      Development/Libraries
Requires:    appcore-agent-devel = %{version}-%{release}

%description -n capi-appfw-service-application-devel
Service Application basic (developement files)

%if 0%{?gcov:1}
%package gcov
Summary:  Service application library(gcov)
Group:    System/API

%description gcov
gcov objects of a service application library
%endif

%package unittests
Summary:  %{name} unittests binary

%description unittests
unittests binary

%prep
%setup -q
cp %{SOURCE1001} .

%build
%if 0%{?gcov:1}
export CFLAGS+=" -fprofile-arcs -ftest-coverage"
export CXXFLAGS+=" -fprofile-arcs -ftest-coverage"
export FFLAGS+=" -fprofile-arcs -ftest-coverage"
export LDFLAGS+=" -lgcov"
%endif

MAJORVER=`echo %{version} | awk 'BEGIN {FS="."}{print $1}'`

%cmake -DFULLVER=%{version} -DMAJORVER=${MAJORVER} \
	.
%__make %{?_smp_mflags}

%install
%make_install

%if 0%{?gcov:1}
builddir=$(basename $PWD)
gcno_obj_dir=%{buildroot}%{_datadir}/gcov/obj/%{name}/"$builddir"
mkdir -p "$gcno_obj_dir"
find . -name '*.gcno' -exec cp --parents '{}' "$gcno_obj_dir" ';'
%endif

## To run unittest
cat << EOF > run-unittest.sh
#!/bin/bash
GCOV_PATH="/tmp/home/abuild/rpmbuild/BUILD"
PAKCAGE="%{name}-%{version}"

set_perm() {
    ## Sets the permission for applications
    /usr/bin/find /tmp/home/ -print | /usr/bin/xargs -n1 /usr/bin/chsmack -a "System::Run" &> /dev/null
    /usr/bin/find /tmp/home/ -print | /usr/bin/xargs -n1 /usr/bin/chsmack -a "System::Run" -t &> /dev/null
    /usr/bin/chmod -R 777 /tmp/home/
}

setup() {
    echo "setup start"
    /usr/bin/mkdir -p "${GCOV_PATH}/${PACKAGE}"
    set_perm
}

test_main() {
    echo "test_main start"
    export "GCOV_PREFIX=/tmp"
    /usr/bin/appcore-agent-test
}

teardown() {
    echo "teardown start"
    set_perm
}

main() {
    setup
    test_main
    teardown
}

main "$@"
EOF

mkdir -p %{buildroot}%{_bindir}/tizen-unittests/%{name}
install -m 0755 run-unittest.sh %{buildroot}%{_bindir}/tizen-unittests/%{name}/

%check
cd unittests
LD_LIBRARY_PATH=../ ctest  -V

%if 0%{?gcov:1}
lcov -c --ignore-errors mismatch,graph,unused --no-external -b . -d . -o %{name}.info
genhtml %{name}.info -o out --legend --show-details
%endif

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%manifest %{name}.manifest
%license LICENSE
%defattr(-,root,root,-)
%{_libdir}/libappcore-agent.so.*

%files devel
%manifest %{name}.manifest
%defattr(-,root,root,-)
%{_libdir}/pkgconfig/appcore-agent.pc
%{_libdir}/libappcore-agent.so


%files -n capi-appfw-service-application-devel
%{_includedir}/appcore-agent/service_app.h
%{_includedir}/appcore-agent/service_app.hpp
%{_includedir}/appcore-agent/service_app_extension.h
%{_includedir}/appcore-agent/service_app_internal.h
%{_libdir}/pkgconfig/capi-appfw-service-application.pc
%{_libdir}/libappcore-agent.so

%if 0%{?gcov:1}
%files gcov
%{_datadir}/gcov/obj/*
%endif

%files unittests
%{_bindir}/appcore-agent-test
%{_bindir}/tizen-unittests/%{name}/run-unittest.sh
