/*
 * Copyright (c) 2020 - 2021 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "appcore_mock.h"
#include "mock_hook.h"
#include "test_fixture.h"

namespace tizen_cpp {

void AppCoreBase::Run(int argc, char** argv) {
  TestFixture::GetMock<AppCoreMock>().Run(argc, argv);
  TestFixture::GetMock<AppCoreMock>().OnLoopInit(argc, argv, this);
  TestFixture::GetMock<AppCoreMock>().OnCreate();
  TestFixture::GetMock<AppCoreMock>().OnLoopRun();
  TestFixture::GetMock<AppCoreMock>().OnLoopFinish();
  TestFixture::GetMock<AppCoreMock>().OnTerminate();
}

void AppCoreBase::Exit() {
  TestFixture::GetMock<AppCoreMock>().Exit();
  TestFixture::GetMock<AppCoreMock>().OnLoopExit();
}

}  // namespace tizen_cpp
