/*
 * Copyright (c) 2020 - 2021 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef MOCK_APPCORE_MOCK_H_
#define MOCK_APPCORE_MOCK_H_

#include <gmock/gmock.h>
#include <app_core_base.hh>

#include "module_mock.h"

class AppCoreMock : public virtual ModuleMock {
 public:
  MOCK_METHOD2(Run, void(int, char**));
  MOCK_METHOD0(Exit, void());
  MOCK_METHOD0(OnCreate, void());
  MOCK_METHOD0(OnTerminate, void());
  MOCK_METHOD3(OnLoopInit, void(int, char**, void*));
  MOCK_METHOD0(OnLoopFinish, void());
  MOCK_METHOD0(OnLoopRun, void());
  MOCK_METHOD0(OnLoopExit, void());
};

#endif  // MOCK_APPCORE_MOCK_H_